/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PTABLE_H__
#define __PTABLE_H__

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include <vpzone.h>
#include <log.h>

ptable_t *pt_create(ptable_type_t type, int size, valuecmp_f value_cmp_function);

int pt_insert(ptable_t *p, void *value);

void *pt_search(ptable_t *p, void *value);

void *pt_remove(ptable_t *p, int index);

int pt_destroy(ptable_t *p);

#endif
