/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __UTILS_H__
#define __UTILS_H__

#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include <vpzone_internal.h>
#include <vpzone.h>
#include <hash.h>
#include <log.h>
#include <plugin.h>

mdevice_t *init_mdevice(char *config_file);

mnode_t *init_mnode(void);

mserver_t *init_mserver();

int init_mdevice_hash(mdevice_t *mdevice);

void free_extents(ptable_t *extents);

void free_mnode(mnode_t *mnode);

void free_mserver(mserver_t *mserver);

void free_mdevice(mdevice_t *mdevice);

int set_extent(bool m_type, void *mthing, int p_id, extent_type_t p_type, extent_t value);

extent_t get_extent(bool m_type, void *mthing, int p_id, extent_type_t p_type);

int parse_connector_line(char *src_line, int *conn_id, int *ac_id, char *host, uint16_t *port);

int parse_address_line(char *src_line, char *address, int *prefix_len);

int compare_ipv6(void *c1, void *c2);

uint32_t hash_ipv6(void *key);

int is_ipv6_unicast(void *c1, void *c2);

#endif
