/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <babeld_cmd.h>

extern in_plugin_handlers_t *ph;

extern char *babeld_params;
extern int hashsize;

int babeld_command_cmd(int argc, char **argv)
{
	if (argc != 2)
	{
		log_msg(ERROR_LVL, "babeld_command: needs one argument (and one only)\n");
		return CMD_ERROR;
	}

	babeld_params = (char *) calloc(strlen(argv[1])+1, sizeof(char));
	if (babeld_params == NULL)
	{
		ERR("babeld_command_cmd()");
		return CMD_ERROR;
	}

	memset(babeld_params, 0, strlen(argv[1])+1);
	strncpy(babeld_params, argv[1], strlen(argv[1]));

	return CMD_SUCCESS;
}

int babeld_hashsize_cmd(int argc, char **argv)
{
	int val;

	if (argc != 2)
	{
		log_msg(ERROR_LVL, "babeld_hashsize: needs one argument (and one only)\n");
		return CMD_ERROR;
	}

	val = (int) strtol(argv[1], NULL, 10);
	if ((errno == ERANGE && (val == INT_MAX || val == INT_MIN))
		|| (errno != 0 && val == 0)) 
	{
		log_msg(ERROR_LVL, "babeld_hashsize: wrong number\n");
		return CMD_ERROR;
	}

	hashsize = val;

	return CMD_SUCCESS;
}
